import _defineProperty from "@babel/runtime/helpers/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React, { forwardRef } from 'react';
import { findDOMNode } from 'react-dom';

/**
 * 获取children的dom ref 同时可以给dom添加react合成事件
 * 原理是劫持了react 的合成事件
 */
class ClassDomNode extends React.PureComponent {
  /**
   * ref 赋值
   */
  assignmentRef() {
    var node = findDOMNode(this);

    if (node && node instanceof Element) {
      //__reactEventHandlers 是16.8在使用的  __reactProps是17使用的
      var [key, targetProps] = Object.entries(node).find((_ref) => {
        var [key] = _ref;
        return key.startsWith('__reactEventHandlers') || key.startsWith('__reactProps');
      }) || [];

      var cloneProps = _objectSpread({}, targetProps);

      var _props = _objectSpread({}, this.props);

      delete _props.__forwardRef;
      delete _props.children;
      Object.entries(_props).forEach((_ref2) => {
        var [prop, value] = _ref2;

        if (value && typeof value !== 'function') {
          console.warn("".concat(prop, " not support"));
        } else if (value) {
          cloneProps[prop] = function () {
            var method = targetProps[prop];

            for (var _len = arguments.length, params = new Array(_len), _key = 0; _key < _len; _key++) {
              params[_key] = arguments[_key];
            }

            method === null || method === void 0 ? void 0 : method(...params);
            value(...params);
          };
        }
      });
      node[key] = cloneProps;
    }

    if (typeof this.props.__forwardRef === 'function') {
      this.props.__forwardRef(node);
    } else {
      this.props.__forwardRef.current = node;
    }
  }
  /**
   *加载完成
   */


  componentDidMount() {
    this.assignmentRef();
  }
  /**
   * 更新后
   */


  componentDidUpdate() {
    this.assignmentRef();
  }
  /**
   *渲染函数
   */


  render() {
    return this.props.children;
  }

}

var Handler = /*#__PURE__*/forwardRef((props, ref) => {
  return /*#__PURE__*/React.createElement(ClassDomNode, _objectSpread(_objectSpread({}, props), {}, {
    __forwardRef: ref
  }));
});
Handler.displayName = 'Handler';
export default Handler;