export default class EventTarget {
  /**
   * 构造函数
   */
  constructor() {
    this.listeners = void 0;
    this.listeners = {};
  }
  /**
   *添加监听
   * @param type
   * @param callback
   */


  addEventListener(type, callback) {
    if (!(type in this.listeners)) {
      this.listeners[type] = [];
    }

    this.listeners[type].push(callback);
  }
  /**
   *移除监听
   * @param type
   * @param callback
   */


  removeEventListener(type, callback) {
    if (!(type in this.listeners)) {
      return;
    }

    var stack = this.listeners[type];

    for (var i = 0, l = stack.length; i < l; i++) {
      if (stack[i] === callback) {
        stack.splice(i, 1);
        return this.removeEventListener(type, callback);
      }
    }
  }
  /**
   *触发监听
   * @param type
   * @param params
   */


  dispatchEvent(type, params) {
    if (!(type in this.listeners)) {
      return;
    }

    var stack = this.listeners[type];

    for (var i = 0, l = stack.length; i < l; i++) {
      stack[i].call(this, params);
    }
  }

}