"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _reactDom = require("react-dom");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/**
 * 获取children的dom ref 同时可以给dom添加react合成事件
 * 原理是劫持了react 的合成事件
 */
var ClassDomNode = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inherits2.default)(ClassDomNode, _React$PureComponent);

  var _super = _createSuper(ClassDomNode);

  function ClassDomNode() {
    (0, _classCallCheck2.default)(this, ClassDomNode);
    return _super.apply(this, arguments);
  }

  (0, _createClass2.default)(ClassDomNode, [{
    key: "assignmentRef",
    value:
    /**
     * ref 赋值
     */
    function assignmentRef() {
      var node = (0, _reactDom.findDOMNode)(this);

      if (node && node instanceof Element) {
        //__reactEventHandlers 是16.8在使用的  __reactProps是17使用的
        var _ref = Object.entries(node).find(function (_ref3) {
          var _ref4 = (0, _slicedToArray2.default)(_ref3, 1),
              key = _ref4[0];

          return key.startsWith('__reactEventHandlers') || key.startsWith('__reactProps');
        }) || [],
            _ref2 = (0, _slicedToArray2.default)(_ref, 2),
            key = _ref2[0],
            targetProps = _ref2[1];

        var cloneProps = _objectSpread({}, targetProps);

        var _props = _objectSpread({}, this.props);

        delete _props.__forwardRef;
        delete _props.children;
        Object.entries(_props).forEach(function (_ref5) {
          var _ref6 = (0, _slicedToArray2.default)(_ref5, 2),
              prop = _ref6[0],
              value = _ref6[1];

          if (value && typeof value !== 'function') {
            console.warn("".concat(prop, " not support"));
          } else if (value) {
            cloneProps[prop] = function () {
              var method = targetProps[prop];

              for (var _len = arguments.length, params = new Array(_len), _key = 0; _key < _len; _key++) {
                params[_key] = arguments[_key];
              }

              method === null || method === void 0 ? void 0 : method.apply(void 0, params);
              value.apply(void 0, params);
            };
          }
        });
        node[key] = cloneProps;
      }

      if (typeof this.props.__forwardRef === 'function') {
        this.props.__forwardRef(node);
      } else {
        this.props.__forwardRef.current = node;
      }
    }
    /**
     *加载完成
     */

  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.assignmentRef();
    }
    /**
     * 更新后
     */

  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.assignmentRef();
    }
    /**
     *渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      return this.props.children;
    }
  }]);
  return ClassDomNode;
}(_react.default.PureComponent);

var Handler = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  return /*#__PURE__*/_react.default.createElement(ClassDomNode, _objectSpread(_objectSpread({}, props), {}, {
    __forwardRef: ref
  }));
});
Handler.displayName = 'Handler';
var _default = Handler;
exports.default = _default;