import React from 'react';
interface OutSideProps {
    onOutSideClick?: (e: React.MouseEvent) => void;
    onClick?: (e: React.MouseEvent) => void;
    onMouseEnter?: (e: React.MouseEvent) => void;
    onMouseLeave?: (e: React.MouseEvent) => void;
    onFocus?: (e: React.FocusEvent) => void;
    onBlur?: (e: React.FocusEvent) => void;
    children?: JSX.Element;
    /**
     * 触发时机 默认为inner
     * inner :只有当你鼠标点击目标后然后鼠标再次点击非目标地方的时候触发
     * 也就是说必须先触发一次 然后才能触发对应的事件
     *
     * outside:一开始点击目标外面就会触发对应的事件
     */
    triggerTiming?: 'inner' | 'outside';
    /**是否只执行一次**/
    once?: boolean;
}
declare const OutSide: React.ForwardRefExoticComponent<OutSideProps & React.RefAttributes<any>>;
export default OutSide;
