export interface Event {
    target?: EventTarget;
    symbol?: symbol;
    callback?: (event: any) => void;
    [key: string]: any;
}
export default class EventTarget {
    private readonly listeners;
    /**
     * 构造函数
     */
    constructor();
    /**
     *添加监听
     * @param type
     * @param callback
     */
    addEventListener(type: string | symbol, callback: (event?: any) => void): void;
    /**
     *移除监听
     * @param type
     * @param callback
     */
    removeEventListener(type: string | symbol, callback: (event?: any) => void): void;
    /**
     *触发监听
     * @param type
     * @param params
     */
    dispatchEvent(type: string | symbol, params?: any): void;
}
