"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var EventTarget = /*#__PURE__*/function () {
  /**
   * 构造函数
   */
  function EventTarget() {
    (0, _classCallCheck2.default)(this, EventTarget);
    this.listeners = void 0;
    this.listeners = {};
  }
  /**
   *添加监听
   * @param type
   * @param callback
   */


  (0, _createClass2.default)(EventTarget, [{
    key: "addEventListener",
    value: function addEventListener(type, callback) {
      if (!(type in this.listeners)) {
        this.listeners[type] = [];
      }

      this.listeners[type].push(callback);
    }
    /**
     *移除监听
     * @param type
     * @param callback
     */

  }, {
    key: "removeEventListener",
    value: function removeEventListener(type, callback) {
      if (!(type in this.listeners)) {
        return;
      }

      var stack = this.listeners[type];

      for (var i = 0, l = stack.length; i < l; i++) {
        if (stack[i] === callback) {
          stack.splice(i, 1);
          return this.removeEventListener(type, callback);
        }
      }
    }
    /**
     *触发监听
     * @param type
     * @param params
     */

  }, {
    key: "dispatchEvent",
    value: function dispatchEvent(type, params) {
      if (!(type in this.listeners)) {
        return;
      }

      var stack = this.listeners[type];

      for (var i = 0, l = stack.length; i < l; i++) {
        stack[i].call(this, params);
      }
    }
  }]);
  return EventTarget;
}();

exports.default = EventTarget;